package ru.kristall.report;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.rmi.RemoteException;
import java.sql.Connection;
import java.util.*;

import javax.mail.Message;
import javax.mail.Session;
import javax.mail.internet.MimeMessage;



import javax.mail.*;
import javax.mail.internet.MimeMessage;

import ru.kristall.utils.*;

import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.alfresco.webservice.authentication.AuthenticationFault;
import org.alfresco.webservice.content.Content;
import org.alfresco.webservice.content.ContentServiceSoapBindingStub;
import org.alfresco.webservice.repository.RepositoryServiceSoapBindingStub;
import org.alfresco.webservice.repository.UpdateResult;
import org.alfresco.webservice.types.CML;
import org.alfresco.webservice.types.CMLCreate;
import org.alfresco.webservice.types.ContentFormat;
import org.alfresco.webservice.types.NamedValue;
import org.alfresco.webservice.types.ParentReference;
import org.alfresco.webservice.types.Reference;
import org.alfresco.webservice.types.Store;
import org.alfresco.webservice.util.AuthenticationUtils;
import org.alfresco.webservice.util.Constants;
import org.alfresco.webservice.util.Utils;
import org.alfresco.webservice.util.WebServiceFactory;

import ru.bitel.bgbilling.server.util.Setup;
import ru.kristall.*;
//import ru.kristall.alfresco.module.bg.soap.File;
import ru.kristall.utils.SmtpMessageSender;


//import com.kristall.UploadContent;

public abstract class BaseReport extends Thread {
	public String name;
	public String user;
	public String email;
	public Hashtable h = new Hashtable();
//	private Properties h = new Properties();
	public Properties prop;
	public Setup lSetup;
	public Connection con;
	public  Logger l;
	public int fl=0;
	
	
	public abstract void execReport ();
	
	
	public abstract void sendFileReport2Ur();
	public void run () {
	  l.logWrite("BaseReport run");
      execReport ();
      l.endLog();
      
//     ClassLoader cl =this.getContextClassLoader();
//  	  cl = null;
//  	  System.gc();    	  
	}

	
	public void setConnection (Connection p) {con=p;}
	public void setSetup(Setup pSetup) {lSetup=pSetup;}
	public void setLogger(Logger pl) {l=pl;}
	public void setEmail(String r) {email=r;}
	public Connection getConnection (){ return con;}
	public Setup getSetup() {return lSetup;}
	public void setRunning() {fl=1;}

	public void setParam(Hashtable pH) {
//	public void setParam(Properties pH) {
    	h=pH;
    	l.logWrite("BaseReport before loadProperty");
		loadProperty();
		Enumeration enumeration = prop.keys();
        while (enumeration.hasMoreElements()){
            String key = enumeration.nextElement().toString();
            l.logWrite(key+" = "+ prop.getProperty(key));
        }		
    	l.logWrite("BaseReport after  loadProperty");
		enumeration = h.keys();
        while (enumeration.hasMoreElements()){
            String key = enumeration.nextElement().toString();
            l.logWrite(key+" = "+ (String) h.get(key));
        }		

    	try { user=(String)h.get("user"); } catch (Exception ee) {}
		try { name=(String)h.get("name"); } catch (Exception ee) {}
		
    }
    
	public void loadProperty(){
		prop = new Properties();
		FileInputStream fis = null;
		try {
			fis = new FileInputStream("data/alfresco.properties"); 
		} catch (FileNotFoundException e) { }
		try {
			if (fis != null) {
				prop.load(fis);
				fis.close();
			}
		} catch (IOException e) {
				System.out.println("Error reading properties file!");
		}		
	}

    public void send2mail(String fName, String fuser, /*String tuser,*/ String smtpHost, String username, String password,String thead, String ttext) throws Exception {
	  try {
		int smtpPort = 25;                //port of smtp mail server
		SmtpMessageSender messageSender = new SmtpMessageSender();
		Session session = messageSender.createSession(smtpHost, smtpPort, username,password);
		MimeMessage message = messageSender.createMimeMessage(session, thead, /*"from@mail.ru"*/ fuser,/*"to@mail.ru"*/ email, Message.RecipientType.TO);
		messageSender.addText(message,ttext,"utf-8","plain");
		if (fName!=null) messageSender.addAttachment(message, new File(fName));
		messageSender.sendMimeMessage(message);
	  }
	  catch( Exception ee) {}
	}
	
	public void sendFileReport2Alfresco(/*String d, */byte [] p) {
	  l.logWrite("BaseReport sendFileReport2Alfresco");
	  Hashtable mt = new Hashtable();
	  l.logWrite("BaseReport sendFileReport2Alfresco 1");
	  mt.put("pdf","application/pdf");
	  mt.put("txt","text/plan");
	  mt.put("html","text/html");
	  mt.put("xml","text/xml");
	  mt.put("doc","application/msword");
	  mt.put("odt","application/vnd.oasis.opendocument.text");
	  mt.put("rtf","application/rtf");
	  mt.put("xls","application/vnd.ms-excel");
	  mt.put("ppt","application/vnd.ms-powerpoint");
	  mt.put("csv","text/csv");
	  l.logWrite("BaseReport sendFileReport2Alfresco 2");
		
	  String fileName=name+"-"+System.currentTimeMillis()+"."+(String)h.get("rtype");
	  l.logWrite("BaseReport sendFileReport2Alfresco 2 "+fileName);


      String serverAddress = prop.getProperty("server.address");
	  String serverPort = prop.getProperty("server.port");
	  String urlString = serverAddress + ":" + serverPort + "/alfresco/soapapi";      
      String userauth = prop.getProperty("server.user");
      String passwdauth = prop.getProperty("server.password");
      l.logWrite("userauth="+userauth+" passwdauth="+passwdauth);
      l.logWrite("urlString="+"http://"+(String)h.get("urla")+"/alfresco/soapapi");
      l.logWrite("user="+user);
      l.logWrite((String)mt.get((String)h.get("rtype")));
      try{
     	 l.logWrite("Before store");
         Store STORE=new Store(Constants.WORKSPACE_STORE,"SpacesStore");
     	 l.logWrite("Before assoc");
         String ASSOC_CONTAINS="{http://www.alfresco.org/model/content/1.0}contains";
    	 l.logWrite("Before setendpoint ");
	     WebServiceFactory.setEndpointAddress("http://"+(String)h.get("urla")+"/alfresco/soapapi");
    	 l.logWrite("Before start session ");
	     AuthenticationUtils.startSession(userauth,passwdauth);
         //Get the content service
    	 l.logWrite("Before contService ");
         ContentServiceSoapBindingStub contService=WebServiceFactory.getContentService();
		 //Create a parent reference
    	 l.logWrite("Before parRef ");
	     ParentReference parRef=new ParentReference(STORE,null,"/app:company_home/app:user_homes/cm:"+user,ASSOC_CONTAINS,"{"+Constants.NAMESPACE_CONTENT_MODEL+"}"+fileName);
	     //Define the content format for the content
	     //we are adding
    	 l.logWrite("Before contentFormat ");
	     ContentFormat contentFormat=new ContentFormat((String)mt.get((String)h.get("rtype")),"cp1251");
//	     ContentFormat contentFormat=new ContentFormat("text/plain","UTF-8");
		     
	     NamedValue[] properties=new NamedValue[]{Utils.createNamedValue(Constants.PROP_NAME,fileName)};
    	 l.logWrite("Before create ");
	     CMLCreate create=new CMLCreate("1",parRef,null,null,null,Constants.TYPE_CONTENT,properties);
	     CML cml=new CML();
	     cml.setCreate(new CMLCreate[]{create});
    	 l.logWrite("Before binding ");
	     ContentServiceSoapBindingStub contentService = WebServiceFactory.getContentService();
    	 l.logWrite("Before Stub ");
	     RepositoryServiceSoapBindingStub repService =WebServiceFactory.getRepositoryService();
    	 l.logWrite("Before update ");
	     UpdateResult[] result=repService.update(cml);
	     //UpdateResult[] result=WebServiceFactory.getRepositoryService().update(cml);
	     Reference newContentNode=result[0].getDestination();
    	 l.logWrite("Before content ");
	     Content content=contService.write(newContentNode,Constants.PROP_CONTENT,p,contentFormat);
         l.logWrite("before end session");
	     AuthenticationUtils.endSession();
         l.logWrite("after end session");
	  }
	  catch (AuthenticationFault e) { e.printStackTrace(); l.logWrite(e, "sendFileReport2Alfresco"); l.endLog();}
	  catch (RemoteException e){e.printStackTrace(); l.logWrite(e, "sendFileReport2Alfresco");l.endLog();}
      catch (Exception exx) {exx.printStackTrace();  l.logWrite(exx, "sendFileReport2Alfresco");l.endLog();}
    finally {mt=null; l.endLog();}
       
	}


}
