package ru.kristall.alfresco.module.bg.soap;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.nio.charset.Charset;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.MimeHeader;
import javax.xml.soap.MimeHeaders;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;

import oracle.xml.parser.v2.XMLDocument;

import org.apache.soap.Envelope;
import org.w3c.dom.Element;
import org.w3c.dom.Text;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

public class SendSOAPMessage {

    private String result = null;

    public String getResult() {  return result; }

    public void setResult(String result) {  this.result = result;  }
    
    
    public SOAPMessage getSoapMessageFromString(String xml) throws SOAPException, IOException {
         MessageFactory factory = MessageFactory.newInstance();
         SOAPMessage message = factory.createMessage(new MimeHeaders(), new ByteArrayInputStream(xml.getBytes(Charset.forName("UTF-8"))));
         return message;
    }

        
    public String getText(SOAPMessage soapMessage) throws SOAPException, IOException {
         ByteArrayOutputStream baos1 = new ByteArrayOutputStream();
         soapMessage.writeTo(baos1);
         String soapMsgStr = new String(baos1.toByteArray());
         return soapMsgStr;
    }
        

}
